<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<title>morphorobotx: /usr/include/c++/4.7.2/bits/stl_vector.h File Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/javascript">
  $(document).ready(function() { searchBox.OnSelectItem(0); });
</script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td style="padding-left: 0.5em;">
   <div id="projectname">morphorobotx
   </div>
   <div id="projectbrief">morphorobotxsharedlibrary</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.1.2 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
          </span>
        </div>
      </li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
<a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(0)"><span class="SelectionMark">&#160;</span>All</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(1)"><span class="SelectionMark">&#160;</span>Files</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(2)"><span class="SelectionMark">&#160;</span>Functions</a></div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_c4a6f9ef9d60515833db96a1f80ff998.html">usr</a></li><li class="navelem"><a class="el" href="dir_18d8996842d9dfe5b3d94b114df19d72.html">include</a></li><li class="navelem"><a class="el" href="dir_0afda7f83df8285aa1c9d1ef64dcef34.html">c++</a></li><li class="navelem"><a class="el" href="dir_b92c0184ad06fae40d4e4cdb0a4094fd.html">4.7.2</a></li><li class="navelem"><a class="el" href="dir_749118bb13af5952b6f0197c3fed6a41.html">bits</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#func-members">Functions</a>  </div>
  <div class="headertitle">
<div class="title">stl_vector.h File Reference</div>  </div>
</div><!--header-->
<div class="contents">
<div class="textblock"><code>#include &lt;bits/stl_iterator_base_funcs.h&gt;</code><br/>
<code>#include &lt;bits/functexcept.h&gt;</code><br/>
<code>#include &lt;bits/concept_check.h&gt;</code><br/>
</div><div class="textblock"><div class="dynheader">
Include dependency graph for stl_vector.h:</div>
<div class="dyncontent">
<div class="center"><img src="stl__vector_8h__incl.png" border="0" usemap="#_2usr_2include_2c_09_09_24_87_82_2bits_2stl__vector_8h" alt=""/></div>
</div>
</div>
<p><a href="stl__vector_8h_source.html">Go to the source code of this file.</a></p>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2><a name="func-members"></a>
Functions</h2></td></tr>
<tr class="memitem:a544d74b2d5d0dd2197f5fd6f02691de0"><td class="memItemLeft" align="right" valign="top">namespace std&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="stl__vector_8h.html#a544d74b2d5d0dd2197f5fd6f02691de0">_GLIBCXX_VISIBILITY</a> (default)</td></tr>
</table>
<a name="details" id="details"></a><h2>Detailed Description</h2>
<div class="textblock"><p>This is an internal header file, included by other library headers. Do not attempt to use it directly. {vector} </p>
</div><h2>Function Documentation</h2>
<a class="anchor" id="a544d74b2d5d0dd2197f5fd6f02691de0"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">namespace std _GLIBCXX_VISIBILITY </td>
          <td>(</td>
          <td class="paramtype">default&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>See bits/stl_deque.h's _Deque_base for an explanation.</p>
<p>A standard container which offers fixed time access to individual elements in any order.</p>
<p>Meets the requirements of a <a href="tables.html#65">container</a>, a <a href="tables.html#66">reversible container</a>, and a <a href="tables.html#67">sequence</a>, including the <a href="tables.html#68">optional sequence requirements</a> with the exception of <code>push_front</code> and <code>pop_front</code>.</p>
<p>In some terminology a vector can be described as a dynamic C-style array, it offers fast and efficient access to individual elements in any order and saves the user from worrying about memory and size allocation. Subscripting ( <code></code>[] ) access is also provided as with C-style arrays.</p>
<p>Default constructor creates no elements.</p>
<p>Creates a vector with no elements. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">__a</td><td>An allocator object.</td></tr>
  </table>
  </dd>
</dl>
<p>Creates a vector with copies of an exemplar element. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">__n</td><td>The number of elements to initially create. </td></tr>
    <tr><td class="paramname">__value</td><td>An element to copy. </td></tr>
    <tr><td class="paramname">__a</td><td>An allocator.</td></tr>
  </table>
  </dd>
</dl>
<p>This constructor fills the vector with <em>__n</em> copies of <em>__value</em>.</p>
<p>Vector copy constructor. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">__x</td><td>A vector of identical element and allocator types.</td></tr>
  </table>
  </dd>
</dl>
<p>The newly-created vector uses a copy of the allocation object used by <em>__x</em>. All the elements of <em>__x</em> are copied, but any extra memory in <em>__x</em> (for fast expansion) will not be copied.</p>
<p>Builds a vector from a range. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">__first</td><td>An input iterator. </td></tr>
    <tr><td class="paramname">__last</td><td>An input iterator. </td></tr>
    <tr><td class="paramname">__a</td><td>An allocator.</td></tr>
  </table>
  </dd>
</dl>
<p>Create a vector consisting of copies of the elements from [first,last).</p>
<p>If the iterators are forward, bidirectional, or random-access, then this will call the elements' copy constructor N times (where N is distance(first,last)) and do no memory reallocation. But if only input iterators are used, then this will do at most 2N calls to the copy constructor, and logN memory reallocations.</p>
<p>The dtor only erases the elements, and note that if the elements themselves are pointers, the pointed-to memory is not touched in any way. Managing the pointer is the user's responsibility.</p>
<p>Vector assignment operator. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">__x</td><td>A vector of identical element and allocator types.</td></tr>
  </table>
  </dd>
</dl>
<p>All the elements of <em>__x</em> are copied, but any extra memory in <em>__x</em> (for fast expansion) will not be copied. Unlike the copy constructor, the allocator object is not copied.</p>
<p>Assigns a given value to a vector. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">__n</td><td>Number of elements to be assigned. </td></tr>
    <tr><td class="paramname">__val</td><td>Value to be assigned.</td></tr>
  </table>
  </dd>
</dl>
<p>This function fills a vector with <em>__n</em> copies of the given value. Note that the assignment completely changes the vector and that the resulting vector's size is the same as the number of elements assigned. Old data may be lost.</p>
<p>Assigns a range to a vector. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">__first</td><td>An input iterator. </td></tr>
    <tr><td class="paramname">__last</td><td>An input iterator.</td></tr>
  </table>
  </dd>
</dl>
<p>This function fills a vector with copies of the elements in the range [<b>first,</b>last).</p>
<p>Note that the assignment completely changes the vector and that the resulting vector's size is the same as the number of elements assigned. Old data may be lost.</p>
<p>Get a copy of the memory allocation object.</p>
<p>Returns a read/write iterator that points to the first element in the vector. Iteration is done in ordinary element order.</p>
<p>Returns a read-only (constant) iterator that points to the first element in the vector. Iteration is done in ordinary element order.</p>
<p>Returns a read/write iterator that points one past the last element in the vector. Iteration is done in ordinary element order.</p>
<p>Returns a read-only (constant) iterator that points one past the last element in the vector. Iteration is done in ordinary element order.</p>
<p>Returns a read/write reverse iterator that points to the last element in the vector. Iteration is done in reverse element order.</p>
<p>Returns a read-only (constant) reverse iterator that points to the last element in the vector. Iteration is done in reverse element order.</p>
<p>Returns a read/write reverse iterator that points to one before the first element in the vector. Iteration is done in reverse element order.</p>
<p>Returns a read-only (constant) reverse iterator that points to one before the first element in the vector. Iteration is done in reverse element order.</p>
<p>Returns the number of elements in the vector.</p>
<p>Returns the size() of the largest possible vector.</p>
<p>Resizes the vector to the specified number of elements. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">__new_size</td><td>Number of elements the vector should contain. </td></tr>
    <tr><td class="paramname">__x</td><td>Data with which new elements should be populated.</td></tr>
  </table>
  </dd>
</dl>
<p>This function will resize the vector to the specified number of elements. If the number is smaller than the vector's current size the vector is truncated, otherwise the vector is extended and new elements are populated with given data.</p>
<p>Returns the total number of elements that the vector can hold before needing to allocate more memory.</p>
<p>Returns true if the vector is empty. (Thus begin() would equal end().)</p>
<p>Attempt to preallocate enough memory for specified number of elements. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">__n</td><td>Number of elements required. </td></tr>
  </table>
  </dd>
</dl>
<dl class="exception"><dt>Exceptions</dt><dd>
  <table class="exception">
    <tr><td class="paramname">std::length_error</td><td>If <em>n</em> exceeds <code>max_size()</code>.</td></tr>
  </table>
  </dd>
</dl>
<p>This function attempts to reserve enough memory for the vector to hold the specified number of elements. If the number requested is more than max_size(), length_error is thrown.</p>
<p>The advantage of this function is that if optimal code is a necessity and the user can determine the number of elements that will be required, the user can reserve the memory in advance, and thus prevent a possible reallocation of memory and copying of vector data.</p>
<p>Subscript access to the data contained in the vector. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">__n</td><td>The index of the element for which data should be accessed. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>Read/write reference to data.</dd></dl>
<p>This operator allows for easy, array-style, data access. Note that data access with this operator is unchecked and out_of_range lookups are not defined. (For checked lookups see at().)</p>
<p>Subscript access to the data contained in the vector. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">__n</td><td>The index of the element for which data should be accessed. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>Read-only (constant) reference to data.</dd></dl>
<p>This operator allows for easy, array-style, data access. Note that data access with this operator is unchecked and out_of_range lookups are not defined. (For checked lookups see at().)</p>
<p>Safety check used only from at().</p>
<p>Provides access to the data contained in the vector. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">__n</td><td>The index of the element for which data should be accessed. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>Read/write reference to data. </dd></dl>
<dl class="exception"><dt>Exceptions</dt><dd>
  <table class="exception">
    <tr><td class="paramname">std::out_of_range</td><td>If <em>__n</em> is an invalid index.</td></tr>
  </table>
  </dd>
</dl>
<p>This function provides for safer data access. The parameter is first checked that it is in the range of the vector. The function throws out_of_range if the check fails.</p>
<p>Provides access to the data contained in the vector. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">__n</td><td>The index of the element for which data should be accessed. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>Read-only (constant) reference to data. </dd></dl>
<dl class="exception"><dt>Exceptions</dt><dd>
  <table class="exception">
    <tr><td class="paramname">std::out_of_range</td><td>If <em>__n</em> is an invalid index.</td></tr>
  </table>
  </dd>
</dl>
<p>This function provides for safer data access. The parameter is first checked that it is in the range of the vector. The function throws out_of_range if the check fails.</p>
<p>Returns a read/write reference to the data at the first element of the vector.</p>
<p>Returns a read-only (constant) reference to the data at the first element of the vector.</p>
<p>Returns a read/write reference to the data at the last element of the vector.</p>
<p>Returns a read-only (constant) reference to the data at the last element of the vector.</p>
<p>Returns a pointer such that [data(), data() + size()) is a valid range. For a non-empty vector, data() == &amp;front().</p>
<p>Add data to the end of the vector. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">__x</td><td>Data to be added.</td></tr>
  </table>
  </dd>
</dl>
<p>This is a typical stack operation. The function creates an element at the end of the vector and assigns the given data to it. Due to the nature of a vector this operation can be done in constant time if the vector has preallocated space available.</p>
<p>Removes last element.</p>
<p>This is a typical stack operation. It shrinks the vector by one.</p>
<p>Note that no data is returned, and if the last element's data is needed, it should be retrieved before pop_back() is called.</p>
<p>Inserts given value into vector before specified iterator. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">__position</td><td>An iterator into the vector. </td></tr>
    <tr><td class="paramname">__x</td><td>Data to be inserted. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>An iterator that points to the inserted data.</dd></dl>
<p>This function will insert a copy of the given value before the specified location. Note that this kind of operation could be expensive for a vector and if it is frequently used the user should consider using std::list.</p>
<p>Inserts a number of copies of given data into the vector. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">__position</td><td>An iterator into the vector. </td></tr>
    <tr><td class="paramname">__n</td><td>Number of elements to be inserted. </td></tr>
    <tr><td class="paramname">__x</td><td>Data to be inserted.</td></tr>
  </table>
  </dd>
</dl>
<p>This function will insert a specified number of copies of the given data before the location specified by <em>position</em>.</p>
<p>Note that this kind of operation could be expensive for a vector and if it is frequently used the user should consider using std::list.</p>
<p>Inserts a range into the vector. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">__position</td><td>An iterator into the vector. </td></tr>
    <tr><td class="paramname">__first</td><td>An input iterator. </td></tr>
    <tr><td class="paramname">__last</td><td>An input iterator.</td></tr>
  </table>
  </dd>
</dl>
<p>This function will insert copies of the data in the range [<b>first,</b>last) into the vector before the location specified by <em>pos</em>.</p>
<p>Note that this kind of operation could be expensive for a vector and if it is frequently used the user should consider using std::list.</p>
<p>Remove element at given position. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">__position</td><td>Iterator pointing to element to be erased. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>An iterator pointing to the next element (or end()).</dd></dl>
<p>This function will erase the element at the given position and thus shorten the vector by one.</p>
<p>Note This operation could be expensive and if it is frequently used the user should consider using std::list. The user is also cautioned that this function only erases the element, and that if the element is itself a pointer, the pointed-to memory is not touched in any way. Managing the pointer is the user's responsibility.</p>
<p>Remove a range of elements. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">__first</td><td>Iterator pointing to the first element to be erased. </td></tr>
    <tr><td class="paramname">__last</td><td>Iterator pointing to one past the last element to be erased. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>An iterator pointing to the element pointed to by <em>__last</em> prior to erasing (or end()).</dd></dl>
<p>This function will erase the elements in the range [<b>first,</b>last) and shorten the vector accordingly.</p>
<p>Note This operation could be expensive and if it is frequently used the user should consider using std::list. The user is also cautioned that this function only erases the elements, and that if the elements themselves are pointers, the pointed-to memory is not touched in any way. Managing the pointer is the user's responsibility.</p>
<p>Swaps data with another vector. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">__x</td><td>A vector of the same element and allocator types.</td></tr>
  </table>
  </dd>
</dl>
<p>This exchanges the elements between two vectors in constant time. (Three pointers, so it should be quite fast.) Note that the global std::swap() function is specialized such that std::swap(v1,v2) will feed to this function.</p>
<p>Erases all the elements. Note that this function only erases the elements, and that if the elements themselves are pointers, the pointed-to memory is not touched in any way. Managing the pointer is the user's responsibility.</p>
<p>Memory expansion handler. Uses the member allocation function to obtain <em>n</em> bytes of memory, and then copies [first,last) into it.</p>
<p>Vector equality comparison. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">__x</td><td>A vector. </td></tr>
    <tr><td class="paramname">__y</td><td>A vector of the same type as <em>__x</em>. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>True iff the size and elements of the vectors are equal.</dd></dl>
<p>This is an equivalence relation. It is linear in the size of the vectors. Vectors are considered equivalent if their sizes are equal, and if corresponding elements compare equal.</p>
<p>Vector ordering relation. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">__x</td><td>A vector. </td></tr>
    <tr><td class="paramname">__y</td><td>A vector of the same type as <em>__x</em>. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>True iff <em>__x</em> is lexicographically less than <em>__y</em>.</dd></dl>
<p>This is a total ordering relation. It is linear in the size of the vectors. The elements must be comparable with <code>&lt;</code>.</p>
<p>See std::lexicographical_compare() for how the determination is made.</p>
<p>Based on operator==</p>
<p>Based on operator&lt;</p>
<p>Based on operator&lt;</p>
<p>Based on operator&lt;</p>
<p>See std::vector::swap(). </p>

</div>
</div>
</div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated on Tue Feb 26 2013 17:15:23 for morphorobotx by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.1.2
</small></address>
</body>
</html>
